#include "TravelCompany.h"

std::ostream& operator << (std::ostream& out, const TravelCompany& data) {
	for (auto i = data.cont.begin(); i != data.cont.end(); ++i) {
		out << std::endl << std::setw(14) << i->tour_name << std::setw(6) << "|" <<
			std::setw(12) << i->surname << std::setw(6) << "|" <<
			std::setw(8) << i->price << std::setw(8) << "|" <<
			std::setw(8) << i->days << std::setw(7) << "|" <<
			std::setw(12) << i->moving_cost << std::setw(10) << "|" <<
			std::setw(14) << i->exchange_rate << std::setw(10) << "|" <<
			std::setw(9) << i->amount << std::setw(8) << "|" <<
			std::setw(12) << i->travel_cost << std::setw(10) << "|" << std::endl;
	}
	return out;
}

std::istream& operator >> (std::istream& in, TravelCompany& data) {
	data = TravelCompany();
	while (true) {
		TravelCompany::Data d;
		in >> d.tour_name;
		if (d.tour_name[0] == '!' || d == TravelCompany::Data()) {
			data.cont.insert(TravelCompany::Data());
			break;
		}
		in >> d.surname;
		in >> d.price;
		in >> d.days;
		in >> d.moving_cost;
		in >> d.exchange_rate;
		in >> d.amount;
		in >> d.travel_cost;
		data.cont.insert(d);
	}
	return in;
}

bool TravelCompany::operator == (const TravelCompany& data) {
	if (cont.size() != data.cont.size())
		return false;
	auto i = cont.begin();
	auto j = data.cont.begin();
	while (i != cont.end() && j != data.cont.end()) {
	    
		TravelCompany::Data d1 = *i;
		TravelCompany::Data d2 = *j;

		if (d1 != d2)
			return false;
		++i;
		++j;
	}
	return true;
}

void TravelCompany::add(std::ofstream& file) {
	for (auto i = cont.begin(); i != cont.end(); ++i) {
	    
		file.write(reinterpret_cast<const char*>(&*i), sizeof(Data)); //!!! Лучше sizeof(Data) (исправлено)
	}
	//file << *this;
}

void TravelCompany::read(std::ifstream& file) {
	while (!file.eof()) {
	    		TravelCompany::Data d;
		file.read(reinterpret_cast<char*>(&d), sizeof(d));
		
		cont.insert(d); //!!! Не нужно писать this там, где он не нужен. (исправлено)
	}
	// file >> *this;
}

void TravelCompany::create_file(std::ofstream& file) {
	TravelCompany data;
	std::cin >> data;
	data.add(file);
}


void TravelCompany::delete_data(std::ofstream& file_write, std::ifstream& file_read) {
	TravelCompany data;
	data.read(file_read);
	bool b = true;
	for (auto i = data.cont.begin(); i != data.cont.end(); ++i) {
		if (b && !const_cast<Data&>(*i).in(this->cont))
			data.add(file_write);
		else
			b = false;
		if (!b)
			data.add(file_write);
	}
}

void TravelCompany::replacement(std::ofstream& file_write, std::ifstream& file_read, TravelCompany& data) {
	delete_data(file_write, file_read); 
	data.add(file_write);
}

void TravelCompany::convert_to_txt(std::ofstream& file_write, std::ifstream& file_read) {

    //!!! Шапку нужно не руками пасать, а программно форматировать и выравнивать текст по центру (исправлено)

	file_write << std::setw(14) << "Tour name" << std::setw(6) << "|" <<
		std::setw(12) << "Surname" << std::setw(6) << "|" <<
		std::setw(10) << "Price" << std::setw(6) << "|" <<
		std::setw(9) << "Days" << std::setw(6) << "|" <<
		std::setw(16) << "Moving cost" << std::setw(6) << "|" <<
		std::setw(18) << "Exchange rate" << std::setw(6) << "|" <<
		std::setw(11) << "Amount" << std::setw(6) << "|" <<
		std::setw(16) << "Travel cost" << std::setw(6) << "|";

	while (!file_read.eof()) {
		TravelCompany data;
		data.read(file_read);
		file_write << data;
	}
}
