#pragma once
#include <fstream>
#include <set>
#include "Exception.h"
#include <iostream>
#include <iomanip>

class TravelCompany {
private:
	struct Data {
		char tour_name[128];
		char surname[128];
		int price;
		int days;
		int moving_cost;
		int exchange_rate;
		int amount;
		int travel_cost;

        //!!!  Среди полей есть массивы. Где конструктор копирования и оператор присваивания? (исправлено)

		Data() :
			price(0),
			days(0),
			moving_cost(0),
			exchange_rate(0),
			amount(0),
			travel_cost(0) 
		{
			tour_name[0] = '\0';
			surname[0] = '\0';
		}

		Data(char name[128],
			char sname[128],
			int price,
			int days,
			int moving_cost,
			int exchange_rate,
			int amount,
			int travel_cost) :
			price(price),
			days(days),
			moving_cost(moving_cost),
			exchange_rate(exchange_rate),
			amount(amount),
			travel_cost(travel_cost)
		{
			for (int i = 0; i < strlen(name); ++i)
				tour_name[i] = name[i];
			tour_name[std::min(strlen(name), size_t(127))] = '\0';

			for (int i = 0; i < strlen(sname); ++i)
				surname[i] = sname[i];
			surname[std::min(strlen(sname), size_t(127))] = '\0';
		}

		Data(const Data& data) {
			for (int i = 0; i < 128; ++i) {
				if (i < strlen(data.tour_name))
					tour_name[i] = data.tour_name[i];
				else {
					tour_name[i] = '\0';
					break;
				}
			}

			for (int i = 0; i < 128; ++i) {
				if (i < strlen(data.surname))
					surname[i] = data.surname[i];
				else {
					surname[i] = '\0';
					break;
				}
			}

			price = data.price;
			days = data.days;
			moving_cost = data.moving_cost;
			exchange_rate = data.exchange_rate;
			amount = data.amount;
			travel_cost = data.travel_cost;
		}

		Data& operator = (const Data& data) {
			for (int i = 0; i < 128; ++i) {
				if (i < strlen(data.tour_name))
					tour_name[i] = data.tour_name[i];
				else {
					tour_name[i] = '\0';
					break;
				}
			}

			for (int i = 0; i < 128; ++i) {
				if (i < strlen(data.surname))
					surname[i] = data.surname[i];
				else {
					surname[i] = '\0';
					break;
				}
			}

			price = data.price;
			days = data.days;
			moving_cost = data.moving_cost;
			exchange_rate = data.exchange_rate;
			amount = data.amount;
			travel_cost = data.travel_cost;
			return *this;
		}

		bool operator == (const Data& data) {
		    
		    //!!! Убрать лишние this (исправлено)
			return (std::strcmp(tour_name, data.tour_name) == 0 &&
				std::strcmp(surname, data.surname) == 0 &&
				price == data.price &&
				days == data.days &&
				moving_cost == data.moving_cost &&
				exchange_rate == data.exchange_rate &&
				amount == data.amount &&
				travel_cost == data.travel_cost);
		}
		bool operator != (const Data& data) {
			return !(*this == data);
		}

		friend bool operator < (const Data& data, const Data& data2) {
			return data.travel_cost < data2.travel_cost;
		}

		bool in(const std::multiset<Data> cont) {
			for (auto i = cont.begin(); i != cont.end(); ++i) {
				if (*this == *i)
					return true;
			}
			return false;
		}

	};

	std::multiset<Data> cont;
public:

	TravelCompany() : cont(std::multiset<Data>()) {}

	TravelCompany(std::multiset<Data> cont) : cont(cont) {}

	bool operator == (const TravelCompany&);

	bool operator != (const TravelCompany& data) {
		return !(*this == data);
	}

	friend std::ostream& operator << (std::ostream&, const TravelCompany&);
	friend std::istream& operator >> (std::istream&, TravelCompany&);

	void add(std::ofstream&);
	void read(std::ifstream&);
	static void create_file(std::ofstream&);

	void delete_data(std::ofstream&, std::ifstream&);
	void replacement(std::ofstream&, std::ifstream&, TravelCompany&);
	static void convert_to_txt(std::ofstream& file_write, std::ifstream& file_read);

};